import { Registry } from "prom-client";
import { Middleware } from "../compose.middleware.js";
import { StorageContext } from "../storage/storage.js";
type MetricRecord = Record<string, string | number>;
export interface MetricsOpts<C extends StorageContext> {
    registry?: Registry;
    labels?: MetricLabelsOpts<C>;
    buckets?: {
        processing?: number[];
        total?: number[];
        relay?: number[];
    };
}
export declare class MetricLabelsOpts<C extends StorageContext> {
    labelNames: string[];
    customizer: (context: C) => Promise<MetricRecord>;
    constructor(labelNames: string[] | undefined, customizer: (ctx: C) => Promise<MetricRecord>);
}
export declare function metrics<C extends StorageContext>(opts?: MetricsOpts<C>): Middleware<C>;
export {};
