import { Cluster, Redis } from "ioredis";
import { Logger } from "winston";
import { SerializableVaaId } from "../../application.js";
import { FilterIdentifier } from "./worker.js";
export declare function markVaaAsSeen(redis: Cluster | Redis, vaaKey: SerializableVaaId, prefix: string): Promise<void>;
export declare function batchMarkAsSeen(redis: Cluster | Redis, prefix: string, emitterChain: number, emitterAddress: string, sequences: string[]): Promise<[void, [error: Error | null, result: unknown][] | null]>;
export declare function batchMarkAsFailedToRecover(redis: Cluster | Redis, prefix: string, emitterChain: number, emitterAddress: string, sequences: string[]): Promise<void>;
export declare function deleteExistingSeenVAAsData(filters: FilterIdentifier[], redis: Cluster | Redis, storagePrefix: string, logger?: Logger): Promise<void>;
export declare function updateSeenSequences(filters: FilterIdentifier[], redis: Redis | Cluster, storagePrefix: string): Promise<number>;
export declare function trySetLastSafeSequence(redis: Redis | Cluster, prefix: string, emitterChain: number, emitterAddress: string, lastSeenSequence: number, logger?: Logger): Promise<boolean>;
export declare function tryGetLastSafeSequence(redis: Redis | Cluster, prefix: string, emitterChain: number, emitterAddress: string, logger?: Logger): Promise<bigint | undefined>;
export declare function tryGetExistingFailedSequences(redis: Cluster | Redis, filter: FilterIdentifier, prefix: string): Promise<string[] | Error>;
export declare function calculateStartingIndex(redis: Redis | Cluster, prefix: string, emitterChain: number, emitterAddress: string, lastSafeSequence?: bigint): Promise<number | null>;
export declare function getAllProcessedSeqsInOrder(redis: Redis | Cluster, prefix: string, emitterChain: number, emitterAddress: string, indexToStartFrom?: number | null, startingSequenceConfig?: bigint): Promise<bigint[]>;
