/// <reference types="node" />
import * as pkg from "@improbable-eng/grpc-web";
import * as http from "http";
/**
 * Transport factory for grpc-web that applies a timeout.
 * Also allows for some more customization of the underlying http request.
 * It's based on @improbable-eng/grpc-web-node-http-transport.
 *
 * @param timeoutMs -  value is passed directly to the timeout option of http.request
 * @param httpOptions - options passed directly to http.request
 * @returns the factory
 */
export declare function FailFastGrpcTransportFactory(timeoutMs?: number, httpOptions?: http.RequestOptions): pkg.grpc.TransportFactory;
export declare class TimeoutError extends Error {
}
