"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStorageMetrics = void 0;
const prom_client_1 = require("prom-client");
function createStorageMetrics(storageRegistry = new prom_client_1.Registry()) {
    return {
        registry: storageRegistry,
        metrics: {
            activeGauge: new prom_client_1.Gauge({
                name: `active_workflows`,
                help: "Total number of active jobs (currently being processed)",
                labelNames: ["queue"],
                registers: [storageRegistry],
            }),
            delayedGauge: new prom_client_1.Gauge({
                name: `delayed_workflows`,
                help: "Total number of jobs that will run in the future",
                labelNames: ["queue"],
                registers: [storageRegistry],
            }),
            waitingGauge: new prom_client_1.Gauge({
                name: `waiting_workflows`,
                help: "Total number of jobs waiting to be processed",
                labelNames: ["queue"],
                registers: [storageRegistry],
            }),
            failedGauge: new prom_client_1.Gauge({
                name: `failed_workflows`,
                help: "Total number of jobs currently in a failed state",
                labelNames: ["queue"],
                registers: [storageRegistry],
            }),
        },
    };
}
exports.createStorageMetrics = createStorageMetrics;
//# sourceMappingURL=storage.metrics.js.map