export function compose(middleware) {
    return async function (ctx, next = () => { }) {
        async function callNext(i) {
            if (i === middleware.length) {
                return next();
            }
            let fn = middleware[i];
            return fn(ctx, callNext.bind(null, i + 1));
        }
        return callNext(0);
    };
}
// error middleware. TODO: cleanup
export function composeError(middleware) {
    return async function (err, ctx, next = () => { }) {
        async function callNext(i) {
            if (i === middleware.length) {
                return next();
            }
            const fn = middleware[i];
            return fn(err, ctx, callNext.bind(null, i + 1));
        }
        return callNext(0);
    };
}
export function isErrorMiddlewareList(list) {
    return list.every(f => {
        return f.length > 2;
    });
}
//# sourceMappingURL=compose.middleware.js.map