import { RelayerApp } from "../../application.js";
import { Plugin } from "./legacy-plugin-definition.js";
import { StorageContext } from "../../storage/storage.js";
import { LoggingContext } from "../logger.middleware.js";
import { StagingAreaContext } from "../staging-area.middleware.js";
import { ProviderContext } from "../providers.middleware.js";
import { WalletContext } from "../wallet/index.js";
export type PluginContext<Ext> = LoggingContext & StorageContext & StagingAreaContext & WalletContext & ProviderContext & Ext;
export declare function legacyPluginCompat<Ext>(app: RelayerApp<PluginContext<Ext>>, plugin: Plugin): void;
