/// <reference types="node" resolution-mode="require"/>
import { Cluster, Redis } from "ioredis";
import { Logger } from "winston";
import { Pool } from "generic-pool";
import { RelayerApp } from "../../application.js";
import { MissedVaaRunStats } from "./helpers.js";
import { FilterIdentifier, MissedVaaOpts } from "./worker.js";
import { Wormholescan } from "../../rpc/wormholescan-client.js";
export type ProcessVaaFn = (x: Buffer) => Promise<void>;
export declare function checkForMissedVaas(filter: FilterIdentifier, redis: Cluster | Redis, processVaa: ProcessVaaFn, opts: MissedVaaOpts, prefix: string, wormholescan: Wormholescan, previousSafeSequence?: bigint, logger?: Logger): Promise<MissedVaaRunStats>;
export declare function refreshSeenSequences(redisPool: Pool<Redis | Cluster>, filters: FilterIdentifier[], opts: MissedVaaOpts): Promise<void>;
export declare function registerEventListeners(app: RelayerApp<any>, redisPool: Pool<Redis | Cluster>, opts: MissedVaaOpts, prefix: string): Promise<void>;
