import { GetSignedVAAResponse } from "@certusone/wormhole-spydk/lib/cjs/proto/publicrpc/v1/publicrpc.js";
import { SerializableVaaId } from "../../application.js";
import { FilterIdentifier } from "./worker.js";
import { MissedVaaMetrics } from "./metrics.js";
export type MissedVaaRunStats = {
    processed: string[];
    seenSequences: string[];
    failedToRecover: string[];
    failedToReprocess: string[];
    lookAheadSequences: string[];
    missingSequences: string[];
};
export type SequenceStats = {
    lastSafeSequence: number;
    lastSeenSequence: number;
    firstSeenSequence: number;
};
export declare function calculateSequenceStats(runStats: MissedVaaRunStats, failedToFetchSequences: string[] | null, previousSafeSequence?: string): SequenceStats;
export declare function updateMetrics(metrics: MissedVaaMetrics, filter: FilterIdentifier, startTime: number, // timestamp in ms
failure: boolean, missedVaas?: MissedVaaRunStats, sequenceStats?: SequenceStats): void;
export declare function tryFetchVaa(vaaKey: SerializableVaaId, wormholeRpcs: string[], retries?: number): Promise<GetSignedVAAResponse | null>;
