/// <reference types="node" resolution-mode="require"/>
/// <reference lib="dom" />
import { Middleware } from "../compose.middleware.js";
import { Context } from "../context.js";
import { Logger } from "winston";
import { Environment } from "../environment.js";
export interface SourceTxOpts {
    wormscanEndpoint: string;
    retries: number;
    initialDelay: number;
    maxDelay: number;
    timeout: number;
}
export interface SourceTxContext extends Context {
    sourceTxHash?: string;
}
export declare function sourceTx(optsWithoutDefaults?: SourceTxOpts): Middleware<SourceTxContext>;
export declare function fetchVaaHash(emitterChain: number, emitterAddress: Buffer, sequence: bigint, env: Environment, logger?: Logger, sourceTxOpts?: SourceTxOpts): Promise<string>;
